import Flutter
import UIKit

public class SwiftFlutterProjectPlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "flutter_project", binaryMessenger: registrar.messenger())
    let instance = SwiftFlutterProjectPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
    if call.method == "getPlatformVersion" {
        result("iOS " + UIDevice.current.systemVersion)
    } else if call.method == "getBatteryLevel" {
        self .getBatteryLevel(result: result)
    }
  }
    
    private func getBatteryLevel(result: FlutterResult) {
        let device = UIDevice.current
        device.isBatteryMonitoringEnabled = true
        if device.batteryState == .unknown {
            result(FlutterError.init(code: "UNAVAILABLE", message: "Battery info unabailable", details: nil))
        } else {
            result(String(device.batteryLevel*100))
        }
    }
}
